import { Service } from "../service";
import * as mongodb from "mongodb";
import * as express from "express";
export declare type Callback<T = any, E extends Error = Error> = (e?: E, result?: T) => void;
export declare const Errors: any;
export interface Blob {
    name: string;
    hash: string;
    mime?: string;
    format?: string;
    id: string;
    size?: number;
    url?: string;
}
export declare class BlobService extends Service {
    private readonly settings;
    readonly name: string;
    blobCollection: mongodb.Collection;
    readonly dependencies: string[];
    readonly collectionName: string;
    services: {
        MongodbService;
        IncrementalIdService;
        ExpressService;
    };
    route: string;
    path: string;
    constructor(settings: {
        blob: {
            webAccessRoute: string;
            blobStorageDir: string;
        };
    });
    private configRouteAndPath();
    initialize(done: any): void;
    redirectToServerPath(req: express.Request, res: express.Response): void;
    createBlob(option: {
        path: string;
        name: string;
    }, callback: Callback<Blob>): void;
    private createBlobFileByHardLink(path, callback);
    getBlob(option: {
        id: string;
    }, callback: Callback<Blob>): void;
    getBlobDownloadUrl(option: {
        id: string;
    }, callback: any): void;
    getBlobUrl(blob: Blob, callback: any): void;
}
